function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
import { defineComponent, $prefix, $props, setup as _setup } from "@dft-vue-2-opentiny/vue-common";
import { renderless, api } from "@dft-vue-2-opentiny/vue-renderless/form-item/vue";
import LabelWrap from "./label-wrap";
import Tooltip from "@dft-vue-2-opentiny/vue-tooltip";
import { IconHelpCircle } from "@dft-vue-2-opentiny/vue-icon";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var $constants = {
  FORM_NAME: "Form",
  FORM_ITEM_NAME: "FormItem"
};
var __vue2_script = defineComponent({
  name: $prefix + "FormItem",
  componentName: "FormItem",
  components: {
    LabelWrap,
    TinyTooltip: Tooltip,
    IconHelpCircle: IconHelpCircle()
  },
  props: _extends({}, $props, {
    _constants: {
      type: Object,
      default: function _default() {
        return $constants;
      }
    },
    appendToBody: {
      type: Boolean,
      default: void 0
    },
    error: String,
    for: String,
    inlineMessage: {
      type: Boolean,
      default: void 0
    },
    messageType: String,
    label: String,
    labelWidth: String,
    manual: Boolean,
    popperOptions: {
      type: Object,
      default: function _default2() {
        return {};
      }
    },
    prop: String,
    required: {
      type: Boolean,
      default: void 0
    },
    rules: [Object, Array],
    showMessage: {
      type: Boolean,
      default: true
    },
    size: String,
    tipContent: String,
    validateDebounce: Boolean,
    validatePosition: String,
    validateStatus: String,
    validateType: String
  }),
  setup: function setup(props, context) {
    return _setup({
      props,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    class: _vm.m("flex min-h-[theme(spacing.12)] sm:min-h-[theme(spacing.7)] mb-0 p-0 sm:mb-4 box-border after:content-[''] after:table after:clear-both before:content-['']  before:table border-b-0.5 border-color-bg-3 sm:border-none", _vm.state.validateState === "error" && _vm.state.validateType === "text" ? "mb-0 sm:mb-0 pb-1 sm:pb-1" : "", _vm.state.formInline ? "align-sub" : "", _vm.state.labelPosition === "top" ? "block mb-4" : "", _vm.state.validateState === "error" ? "[&_input]:border-color-error [&_textarea]:border-color-error [&_input:focus]:border-color-error [&_input:hover]:border-color-error [&_textarea:focus]:border-color-error [&_textarea:hover]:border-color-error" : "", _vm.state.labelPosition === "top" && !_vm.state.hideRequiredAsterisk ? "pl-0" : "", ["small", "mini"].indexOf(_vm.state.formItemSize) >= 0 ? "mb-2" : "", !_vm.slots.label && !_vm.label ? "border-none" : "", _vm.state.isDisplayOnly ? "border-none py-0.5" : ""),
    attrs: {
      "data-tag": "tiny-from-item"
    }
  }, [_c("label-wrap", {
    attrs: {
      "is-auto-width": _vm.state.labelStyle && _vm.state.labelStyle.width === "auto",
      "update-all": _vm.state.labelWidth === "auto",
      "is-mobile-first": true
    }
  }, [_vm.slots.label || _vm.label ? _c("label", {
    class: _vm.m("py-3 sm:py-1.5 sm:min-h-[theme(spacing.7)] relative align-bottom float-left text-sm sm:text-xs text-color-text-secondary pr-0 sm:pr-4 box-border", "overflow-hidden text-ellipsis text-left sm:text-right", _vm.state.labelPosition === "top" ? "float-none inline-block text-left leading-none px-0 pt-0 pb-1.5 h-auto min-h-0" : "min-h-[theme(spacing.9)]", _vm.state.labelPosition === "left" ? "text-left" : "", _vm.state.formInline && _vm.state.labelPosition === "top" ? "block" : "", _vm.state.isDisplayOnly ? "leading-none h-auto align-[inherit] pr-4" : "", _vm.tipContent ? "pr-5 sm:pr-7" : "", _vm.state.labelPosition === "top" && !_vm.state.hideRequiredAsterisk ? "overflow-visible relative before:absolute before:-left-2.5" : ""),
    style: _vm.state.labelStyle,
    attrs: {
      "data-tag": "tiny-item-label",
      "for": _vm.state.labelFor
    }
  }, [_c("span", {
    class: _vm.m("max-h-[theme(spacing.10)] line-clamp-2 inline-block relative top-px pl-2 sm:pl-0 leading-normal", (_vm.state.isRequired || _vm.required) && !_vm.state.hideRequiredAsterisk ? "before:content-['*'] before:text-color-error before:absolute before:left-0 before:sm:relative" : "", _vm.state.isDisplayOnly ? "pl-0 before:hidden" : "")
  }, [_vm._t("label", [_vm._v(" " + _vm._s(_vm.label + _vm.state.labelSuffix) + " ")])], 2), _vm.tipContent ? _c("tiny-tooltip", {
    attrs: {
      "effect": "light",
      "content": _vm.tipContent,
      "placement": "top"
    }
  }, [_c("icon-help-circle", {
    class: [_vm.state.labelPosition === "top" ? "top-0.5 sm:top-1.5" : "top-3.5 sm:top-1.5"],
    attrs: {
      "custom-class": "h-4 w-4 ml-0.5 absolute right-1 sm:right-2 align-text-bottom fill-color-text-secondary"
    }
  })], 1) : _vm._e()], 1) : _vm._e()]), _c("div", {
    class: _vm.m("m-auto flex-1 relative sm:top-auto text-sm sm:text-xs  after:content-['']  after:table after:clear-both before:content-['']  before:table [&_button:not(:last-child)]:mr-2", "[&_[data-tag=tiny-checkbox]]:py-0 [&_[data-tag=tiny-input]]:w-full [&_[data-tag=tiny-input]_textarea]:w-full [&_[data-tag=tiny-input]_textarea]:pt-3.5 sm:[&_[data-tag=tiny-input]_textarea]:pt-2", _vm.state.formInline ? "align-sub leading-none" : "", _vm.state.labelPosition === "top" && !_vm.state.hideRequiredAsterisk ? "pl-2.5 sm:pl-0 [&_[data-tag=tiny-input]_input]:px-0 sm:[&_[data-tag=tiny-input]_input]:px-3" : ""),
    attrs: {
      "data-tag": "tiny-from-item-inline"
    }
  }, [_vm.state.isDisplayOnly && _vm.state.isBasicComp ? _c("div", {
    class: ["break-all", _vm.state.typeName === "textarea" ? "line-clamp-3" : "line-clamp-1"],
    attrs: {
      "data-tag": "tiny-from-item-display-only",
      "type-name": _vm.state.typeName
    },
    on: {
      "mouseenter": _vm.handleMouseenter,
      "mouseleave": _vm.handleMouseleave
    }
  }, [_vm._v(" " + _vm._s(_vm.state.displayedValue || "-") + " ")]) : _vm._e(), _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: !(_vm.state.isDisplayOnly && _vm.state.isBasicComp),
      expression: "!(state.isDisplayOnly && state.isBasicComp)"
    }],
    class: ["[&_[aria-label=checkbox-group]]:pl-0.5 sm:[&_[aria-label=checkbox-group]]:pl-0", "[&_>:first-child[data-tag=tiny-checkbox]]:pl-0.5 sm:[&_>:first-child[data-tag=tiny-checkbox]]:pl-0", !_vm.state.isDisplayOnly ? "[&_[data-tag=tiny-switch]]:ml-2.5 sm:[&_[data-tag=tiny-switch]]:ml-0 [&_[data-tag=tiny-numeric]]:ml-2.5 sm:[&_[data-tag=tiny-numeric]]:ml-0" : ""],
    attrs: {
      "data-tag": "tiny-from-item-show"
    }
  }, [_vm._t("default")], 2), _vm.state.validateState === "error" && _vm.showMessage && _vm.state.showMessage ? _vm._t("error", [_c("div", {
    class: _vm.m("relative text-color-error text-xs leading-normal pt-1", typeof _vm.inlineMessage === "boolean" && _vm.inlineMessage || _vm.state.inlineMessage ? "relative top-auto left-auto inline-block ml-2.5" : "", _vm.state.formItemSize === "small" ? "pt-0.5" : "", _vm.state.formItemSize === "mini" ? "pt-px" : "")
  }, [_vm._v(" " + _vm._s(_vm.state.validateMessage) + " ")])], {
    "dataTag": "tiny-from-item-error"
  }) : _vm._e()], 2)], 1);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var mobileFirst = /* @__PURE__ */ function() {
  return __component__.exports;
}();
export {
  mobileFirst as default
};
